unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus,DXClass, DXSprite, DXInput, DXDraws,
  DXSounds, DIB, MPlayer, ComCtrls, FileSrc, Scorebox;

type
  TGameScene = (
    gsNone,
    gsTitle,
    gsMain,
    gsGameOver,
    gsMain2,
    gsMain3,
    gsMain4,
    gsMain5,
    gsMain6,
    gsMain7,
    gsMain8,
    gsMain9,
    gsMain10,
    gsEndGame
  );

  TMainForm = class(TDXForm)
    DXTimer: TDXTimer;
    DXDraw: TDXDraw;
    SpriteEngine: TDXSpriteEngine;
    DXInput: TDXInput;
    ImageList: TDXImageList;
    DXWaveList: TDXWaveList;
    DXSound: TDXSound;
    MainMenu: TMainMenu;
    GameMenu: TMenuItem;
    GameStart: TMenuItem;
    GamePause: TMenuItem;
    GameExit: TMenuItem;
    OptionMenu: TMenuItem;
    OptionFullScreen: TMenuItem;
    OptionSound: TMenuItem;
    N4: TMenuItem;
    N3: TMenuItem;
    Help1: TMenuItem;
    Helpongame1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    HighScores1: TMenuItem;
    FileSource: TFileSource;
    ScoreBox: TScoreBox;
    Music: TMediaPlayer;
    StatusBar: TStatusBar;
    procedure DXDrawFinalize(Sender: TObject);
    procedure DXDrawInitialize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure DXTimerActivate(Sender: TObject);
    procedure DXTimerDeactivate(Sender: TObject);
    procedure OptionFullScreenClick(Sender: TObject);
    procedure DXDrawInitializing(Sender: TObject);
    procedure GameStartClick(Sender: TObject);
    procedure GamePauseClick(Sender: TObject);
    procedure GameExitClick(Sender: TObject);
    procedure OptionSoundClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OptionShowFPSClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure About1Click(Sender: TObject);
    procedure HighScores1Click(Sender: TObject);
    procedure MusicNotify(Sender: TObject);
  private
    FScene: TGameScene;
    FNextScene: TGameScene;
    FBlink: Integer;
    FBlinkTime: Integer;
    FEnemyAdventPos: Integer;
    FFrame: Integer;
    FHitPoint: Integer;
    FTokuten: Integer;
    procedure BlinkStart;
    procedure BlinkUpdate;
    procedure PlaySound(const Name: string; Wait: Boolean);
    procedure PalleteAnim(Col: TRGBQuad; Time: Integer);
    procedure StartScene(Scene: TGameScene);
    procedure StartSceneTitle;
    procedure StartSceneMain;
    procedure StartSceneGameOver;
//    procedure StartEndGame;
    procedure EndScene;
    procedure EndSceneTitle;
    procedure EndSceneMain;
    procedure EndSceneMain2;
    procedure EndSceneMain3;
    procedure EndSceneMain4;
    procedure EndSceneMain5;
    procedure EndSceneMain6;
    procedure EndSceneMain7;
    procedure EndSceneMain8;
    procedure EndSceneMain9;
    procedure EndSceneMain10;
    procedure EndSceneGameOver;
//    procedure EndSceneEndGame;
    procedure SceneTitle;
    procedure SceneMain;
    procedure SceneMain2;
    procedure SceneMain3;
    procedure SceneMain4;
    procedure SceneMain5;
    procedure SceneMain6;
    procedure SceneMain7;
    procedure SceneMain8;
    procedure SceneMain9;
    procedure SceneMain10;
    procedure StartSceneMain2;
    procedure StartSceneMain3;
    procedure StartSceneMain4;
    procedure StartSceneMain5;
    procedure StartSceneMain6;
    procedure StartSceneMain7;
    procedure StartSceneMain8;
    procedure StartSceneMain9;
    procedure StartSceneMain10;
    procedure SceneGameOver;
    procedure SceneEndGame;
  end;

var
  MainForm: TMainForm;

implementation

uses About;

{$R *.DFM}

type
  TPlayerSprite = class(TImageSprite)
  private
    FCounter: Integer;
    FMode: Integer;
    FTamaCount: Integer;
    FOldTamaTime: Integer;
  protected
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
    procedure DoMove(MoveCount: Integer); override;

  public
    constructor Create(AParent: TSprite); override;
  end;

  TTamaSprite = class(TImageSprite)
  private
    FPlayerSprite: TPlayerSprite;
  protected
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
    procedure DoMove(MoveCount: Integer); override;
  public
    constructor Create(AParent: TSprite); override;
    destructor Destroy; override;
  end;

  TScrollBackground = class(TBackgroundSprite)
  private
    FSpeed: Double;
  protected
    procedure DoMove(MoveCount: Integer); override;
  end;

  TBakuhatu = class(TImageSprite)
  protected
    procedure DoMove(MoveCount: Integer); override;
  public
    constructor Create(AParent: TSprite); override;
  end;

  TEnemy = class(TImageSprite)
  private
    FCounter: Integer;
    FLife: Integer;
    FMode: Integer;
    procedure Hit; virtual;
  protected
    procedure HitEnemy(Deaded: Boolean); virtual;
  end;

  TEnemyTama = class(TEnemy)
  private
    FPlayerSprite: TSprite;
  protected
    procedure DoMove(MoveCount: Integer); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 

  TEnemyUFO = class(TEnemy)
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;

    TEnemyUFO2 = class(TEnemy)
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;


  TEnemyAttacker = class(TEnemy)
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;

  //Nouveau Attacker
  TEnemyAttacker2 = class(TEnemy)
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
// Fin attacker

  TEnemyAttacker3 = class(TEnemy)
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;


  TEnemyBoss = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;

 // Boss 2
  TEnemyBoss2 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss2

 // Boss 3
  TEnemyBoss3 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss3

  // Boss 4
  TEnemyBoss4 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss4

  // Boss 5
  TEnemyBoss5 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss5

  // Boss 6
  TEnemyBoss6 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss6

  // Boss 7
  TEnemyBoss7 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss7

  // Boss 8
  TEnemyBoss8 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss8

  // Boss 9
  TEnemyBoss9 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss9

  // Boss 10
  TEnemyBoss10 = class(TEnemy)
  private
    FCounter: Integer;
    FTamaF: Integer;
    FTamaT: Integer;
    FPutTama: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure HitEnemy(Deaded: Boolean); override;
  public
    constructor Create(AParent: TSprite); override;
  end;
 // Fin Boss10

  TSpriteClass = class of TSprite;

  TEnemyAdvent = record
    f: Integer;
    c: TSpriteClass;
    x: Integer;
    y: Integer;
  end;

const
  EnemyAdventTable: array[0..47] of TEnemyAdvent = (
    (f: 100; c: TEnemyUFO; x: 0; y: 0),
    (f: 100; c: TEnemyUFO; x: 0; y: 120),
    (f: 100; c: TEnemyUFO; x: 0; y: 240),
    (f: 100; c: TEnemyUFO; x: 0; y: 360),

    (f: 200; c: TEnemyUFO; x: 0; y: 60),
    (f: 200; c: TEnemyUFO; x: 0; y: 180),
    (f: 200; c: TEnemyUFO; x: 0; y: 300),
    (f: 200; c: TEnemyUFO; x: 0; y: 420),

    (f: 300; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 325; c: TEnemyUFO; x: 0; y: -60),
    (f: 350; c: TEnemyUFO; x: 0; y: 60),
    (f: 375; c: TEnemyUFO; x: 0; y: 180),
    (f: 390; c: TEnemyUFO; x: 0; y: 300),

    (f: 400; c: TEnemyAttacker; x: 0; y: 100),
    (f: 420; c: TEnemyAttacker; x: 0; y: 200),
    (f: 440; c: TEnemyAttacker; x: 0; y: 300),
    (f: 450; c: TEnemyAttacker; x: 0; y: 200),
    (f: 455; c: TEnemyAttacker; x: 0; y: 100),

    (f: 460; c: TEnemyUFO; x: 0; y: 240),
    (f: 470; c: TEnemyUFO; x: 0; y: 240),
    (f: 480; c: TEnemyUFO; x: 0; y: 240),
    (f: 490; c: TEnemyUFO; x: 0; y: 240),
    (f: 500; c: TEnemyUFO; x: 0; y: 240),

    (f: 520; c: TEnemyAttacker; x: 0; y: 240),
    (f: 530; c: TEnemyAttacker; x: 0; y: 240),
    (f: 540; c: TEnemyAttacker; x: 0; y: 240),
    (f: 550; c: TEnemyAttacker; x: 0; y: 240),
    (f: 560; c: TEnemyAttacker; x: 0; y: 240),

    (f: 570; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 580; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 590; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 600; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 605; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 615; c: TEnemyUFO2; x: 0; y: 100),
    (f: 630; c: TEnemyUFO2; x: 0; y: 200),
    (f: 640; c: TEnemyUFO2; x: 0; y: 300),
    (f: 650; c: TEnemyUFO2; x: 0; y: 200),
    (f: 660; c: TEnemyUFO2; x: 0; y: 100),

    (f: 680; c: TEnemyAttacker3; x: 0; y: 100),
    (f: 700; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 720; c: TEnemyAttacker3; x: 0; y: 300),
    (f: 740; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 740; c: TEnemyAttacker3; x: 0; y: 100),

    (f: 760; c: TEnemyBoss; x: 0; y: 200)
  );

// Niveau 2

 EnemyAdventTable2: array[0..47] of TEnemyAdvent = (


    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 160; c: TEnemyUFO; x: 0; y: 240),
    (f: 170; c: TEnemyUFO; x: 0; y: 240),
    (f: 180; c: TEnemyUFO; x: 0; y: 240),
    (f: 190; c: TEnemyUFO; x: 0; y: 240),
    (f: 200; c: TEnemyUFO; x: 0; y: 240),

    (f: 220; c: TEnemyAttacker; x: 0; y: 300),
    (f: 230; c: TEnemyAttacker; x: 0; y: 200),
    (f: 240; c: TEnemyAttacker; x: 0; y: 250),
    (f: 250; c: TEnemyAttacker; x: 0; y: 200),
    (f: 260; c: TEnemyAttacker; x: 0; y: 300),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 100; c: TEnemyUFO; x: 0; y: 0),
    (f: 350; c: TEnemyUFO; x: 0; y: 120),
    (f: 350; c: TEnemyUFO; x: 0; y: 240),
    (f: 350; c: TEnemyUFO; x: 0; y: 360),

    (f: 500; c: TEnemyUFO; x: 0; y: 60),
    (f: 510; c: TEnemyUFO; x: 0; y: 180),
    (f: 520; c: TEnemyUFO; x: 0; y: 300),
    (f: 530; c: TEnemyUFO; x: 0; y: 420),

    (f: 220; c: TEnemyAttacker; x: 0; y: 240),
    (f: 230; c: TEnemyAttacker; x: 0; y: 240),
    (f: 240; c: TEnemyAttacker; x: 0; y: 240),
    (f: 250; c: TEnemyAttacker; x: 0; y: 240),
    (f: 260; c: TEnemyAttacker; x: 0; y: 240),

    (f: 550; c: TEnemyUFO; x: 0; y: -60),
    (f: 550; c: TEnemyUFO; x: 0; y: 60),
    (f: 550; c: TEnemyUFO; x: 0; y: 180),
    (f: 550; c: TEnemyUFO; x: 0; y: 300),

    (f: 580; c: TEnemyUFO2; x: 0; y: 100),
    (f: 600; c: TEnemyUFO2; x: 0; y: 200),
    (f: 620; c: TEnemyUFO2; x: 0; y: 300),
    (f: 640; c: TEnemyUFO2; x: 0; y: 200),
    (f: 660; c: TEnemyUFO2; x: 0; y: 100),

    (f: 700; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 710; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 720; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 730; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 740; c: TEnemyAttacker3; x: 0; y: 240),


    (f: 760; c: TEnemyBoss2; x: 0; y: 200 )
  );

// Fin niveau 2

// Niveau 3

 EnemyAdventTable3: array[0..47] of TEnemyAdvent = (

    (f: 50; c: TEnemyAttacker3; x: 0; y: 100),
    (f: 60; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 70; c: TEnemyAttacker3; x: 0; y: 300),
    (f: 80; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 95; c: TEnemyAttacker3; x: 0; y: 100),

    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 160; c: TEnemyUFO; x: 0; y: 240),
    (f: 170; c: TEnemyUFO; x: 0; y: 240),
    (f: 180; c: TEnemyUFO; x: 0; y: 240),
    (f: 190; c: TEnemyUFO; x: 0; y: 240),
    (f: 200; c: TEnemyUFO; x: 0; y: 240),

    (f: 220; c: TEnemyAttacker; x: 0; y: 240),
    (f: 230; c: TEnemyAttacker; x: 0; y: 240),
    (f: 240; c: TEnemyAttacker; x: 0; y: 240),
    (f: 250; c: TEnemyAttacker; x: 0; y: 240),
    (f: 260; c: TEnemyAttacker; x: 0; y: 240),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 100; c: TEnemyUFO; x: 0; y: 0),
    (f: 350; c: TEnemyUFO; x: 0; y: 120),
    (f: 350; c: TEnemyUFO; x: 0; y: 240),
    (f: 350; c: TEnemyUFO; x: 0; y: 360),

    (f: 450; c: TEnemyUFO; x: 0; y: 60),
    (f: 450; c: TEnemyUFO; x: 0; y: 180),
    (f: 450; c: TEnemyUFO; x: 0; y: 300),
    (f: 450; c: TEnemyUFO; x: 0; y: 420),

    (f: 550; c: TEnemyUFO; x: 0; y: -60),
    (f: 550; c: TEnemyUFO; x: 0; y: 60),
    (f: 550; c: TEnemyUFO; x: 0; y: 180),
    (f: 550; c: TEnemyUFO; x: 0; y: 300),

    (f: 600; c: TEnemyAttacker; x: 0; y: 240),
    (f: 600; c: TEnemyAttacker; x: 0; y: 240),
    (f: 600; c: TEnemyAttacker; x: 0; y: 240),
    (f: 600; c: TEnemyAttacker; x: 0; y: 240),
    (f: 600; c: TEnemyAttacker; x: 0; y: 240),

    (f: 620; c: TEnemyAttacker2; x: 0; y: 250),
    (f: 620; c: TEnemyAttacker2; x: 0; y: 250),
    (f: 620; c: TEnemyAttacker2; x: 0; y: 250),
    (f: 620; c: TEnemyAttacker2; x: 0; y: 250),
    (f: 620; c: TEnemyAttacker2; x: 0; y: 250),

    (f: 635; c: TEnemyBoss3; x: 0; y: 200 )
  );

// Fin niveau 3

// Niveau 4

 EnemyAdventTable4: array[0..47] of TEnemyAdvent = (


    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 160; c: TEnemyUFO; x: 0; y: 100),
    (f: 170; c: TEnemyUFO; x: 0; y: 200),
    (f: 180; c: TEnemyUFO; x: 0; y: 300),
    (f: 190; c: TEnemyUFO; x: 0; y: 200),
    (f: 200; c: TEnemyUFO; x: 0; y: 100),

    (f: 220; c: TEnemyAttacker; x: 0; y: 100),
    (f: 230; c: TEnemyAttacker; x: 0; y: 200),
    (f: 240; c: TEnemyAttacker; x: 0; y: 300),
    (f: 250; c: TEnemyAttacker; x: 0; y: 200),
    (f: 260; c: TEnemyAttacker; x: 0; y: 100),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 100; c: TEnemyUFO; x: 0; y: 0),
    (f: 350; c: TEnemyUFO; x: 0; y: 120),
    (f: 350; c: TEnemyUFO; x: 0; y: 240),
    (f: 350; c: TEnemyUFO; x: 0; y: 360),

    (f: 450; c: TEnemyUFO; x: 0; y: 60),
    (f: 450; c: TEnemyUFO; x: 0; y: 180),
    (f: 450; c: TEnemyUFO; x: 0; y: 300),
    (f: 450; c: TEnemyUFO; x: 0; y: 420),

    (f: 550; c: TEnemyUFO; x: 0; y: -60),
    (f: 550; c: TEnemyUFO; x: 0; y: 60),
    (f: 550; c: TEnemyUFO; x: 0; y: 180),
    (f: 550; c: TEnemyUFO; x: 0; y: 300),

    (f: 580; c: TEnemyUFO2; x: 0; y: 100),
    (f: 600; c: TEnemyUFO2; x: 0; y: 200),
    (f: 620; c: TEnemyUFO2; x: 0; y: 300),
    (f: 640; c: TEnemyUFO2; x: 0; y: 200),
    (f: 660; c: TEnemyUFO2; x: 0; y: 100),

    (f: 680; c: TEnemyAttacker3; x: 0; y: 100),
    (f: 700; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 720; c: TEnemyAttacker3; x: 0; y: 300),
    (f: 740; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 750; c: TEnemyAttacker3; x: 0; y: 100),

    (f: 770; c: TEnemyUFO2; x: 0; y: 0),
    (f: 780; c: TEnemyUFO2; x: 0; y: 120),
    (f: 790; c: TEnemyUFO2; x: 0; y: 240),
    (f: 800; c: TEnemyUFO2; x: 0; y: 360),

    (f: 805; c: TEnemyAttacker; x: 0; y: 100),

    (f: 815; c: TEnemyBoss4; x: 0; y: 200 )
  );

// Fin niveau 4

// Niveau 5

 EnemyAdventTable5: array[0..51]of TEnemyAdvent = (


    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 100; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 160; c: TEnemyUFO; x: 0; y: 300),
    (f: 170; c: TEnemyUFO; x: 0; y: 100),
    (f: 180; c: TEnemyUFO; x: 0; y: 200),
    (f: 190; c: TEnemyUFO; x: 0; y: 300),
    (f: 200; c: TEnemyUFO; x: 0; y: 200),

    (f: 200; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 205; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 210; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 215; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 220; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 225; c: TEnemyAttacker; x: 0; y: 150),
    (f: 230; c: TEnemyAttacker; x: 0; y: 150),
    (f: 240; c: TEnemyAttacker; x: 0; y: 150),
    (f: 250; c: TEnemyAttacker; x: 0; y: 150),
    (f: 260; c: TEnemyAttacker; x: 0; y: 150),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 100; c: TEnemyUFO; x: 0; y: 0),
    (f: 350; c: TEnemyUFO; x: 0; y: 120),
    (f: 350; c: TEnemyUFO; x: 0; y: 240),
    (f: 350; c: TEnemyUFO; x: 0; y: 360),

    (f: 450; c: TEnemyUFO; x: 0; y: 60),
    (f: 450; c: TEnemyUFO; x: 0; y: 180),
    (f: 450; c: TEnemyUFO; x: 0; y: 300),
    (f: 450; c: TEnemyUFO; x: 0; y: 420),

    (f: 460; c: TEnemyAttacker3; x: 0; y: 100),
    (f: 470; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 480; c: TEnemyAttacker3; x: 0; y: 300),
    (f: 500; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 520; c: TEnemyAttacker3; x: 0; y: 100),

    (f: 550; c: TEnemyUFO; x: 0; y: -60),
    (f: 550; c: TEnemyUFO; x: 0; y: 60),
    (f: 550; c: TEnemyUFO; x: 0; y: 180),
    (f: 550; c: TEnemyUFO; x: 0; y: 300),

    (f: 570; c: TEnemyUFO2; x: 0; y: -60),
    (f: 575; c: TEnemyUFO2; x: 0; y: 60),
    (f: 580; c: TEnemyUFO2; x: 0; y: 180),
    (f: 585; c: TEnemyUFO2; x: 0; y: 300),

    (f: 615; c: TEnemyBoss5; x: 0; y: 200 )
  );

// Fin niveau 5

// Niveau 6

 EnemyAdventTable6: array[0..42] of TEnemyAdvent = (


    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 160; c: TEnemyUFO; x: 0; y: 200),
    (f: 170; c: TEnemyUFO; x: 0; y: 250),
    (f: 180; c: TEnemyUFO; x: 0; y: 300),
    (f: 190; c: TEnemyUFO; x: 0; y: 100),
    (f: 200; c: TEnemyUFO; x: 0; y: 150),

    (f: 220; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 230; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 240; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 250; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 260; c: TEnemyAttacker3; x: 0; y: 240),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 100; c: TEnemyUFO; x: 0; y: 0),
    (f: 350; c: TEnemyUFO; x: 0; y: 120),
    (f: 350; c: TEnemyUFO; x: 0; y: 240),
    (f: 350; c: TEnemyUFO; x: 0; y: 360),

    (f: 450; c: TEnemyUFO; x: 0; y: 60),
    (f: 450; c: TEnemyUFO; x: 0; y: 180),
    (f: 450; c: TEnemyUFO; x: 0; y: 300),
    (f: 450; c: TEnemyUFO; x: 0; y: 420),

    (f: 500; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker3; x: 0; y: 240),

    (f: 520; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 520; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 520; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 520; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 520; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 550; c: TEnemyUFO2; x: 0; y: -60),
    (f: 550; c: TEnemyUFO2; x: 0; y: 60),
    (f: 550; c: TEnemyUFO2; x: 0; y: 180),
    (f: 550; c: TEnemyUFO2; x: 0; y: 300),


    (f: 615; c: TEnemyBoss6; x: 0; y: 200 )
  );

// Fin niveau 6

// Niveau 7

 EnemyAdventTable7: array[0..53] of TEnemyAdvent = (


    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 160; c: TEnemyUFO; x: 0; y: 260),
    (f: 170; c: TEnemyUFO; x: 0; y: 80),
    (f: 180; c: TEnemyUFO; x: 0; y: 300),
    (f: 190; c: TEnemyUFO; x: 0; y: 280),
    (f: 200; c: TEnemyUFO; x: 0; y: 230),

    (f: 220; c: TEnemyAttacker; x: 0; y: 300),
    (f: 230; c: TEnemyAttacker; x: 0; y: 200),
    (f: 240; c: TEnemyAttacker; x: 0; y: 150),
    (f: 250; c: TEnemyAttacker; x: 0; y: 100),
    (f: 260; c: TEnemyAttacker; x: 0; y: 50),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 320; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 330; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 340; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 350; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 360; c: TEnemyAttacker3; x: 0; y: 240),

    (f: 370; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 380; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 390; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 400; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 410; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 425; c: TEnemyUFO; x: 0; y: 0),
    (f: 450; c: TEnemyUFO; x: 0; y: 120),
    (f: 460; c: TEnemyUFO; x: 0; y: 240),
    (f: 470; c: TEnemyUFO; x: 0; y: 360),

    (f: 480; c: TEnemyUFO2; x: 0; y: 60),
    (f: 480; c: TEnemyUFO2; x: 0; y: 180),
    (f: 480; c: TEnemyUFO2; x: 0; y: 300),
    (f: 480; c: TEnemyUFO2; x: 0; y: 420),

    (f: 500; c: TEnemyAttacker; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker; x: 0; y: 240),
    (f: 500; c: TEnemyAttacker; x: 0; y: 240),

    (f: 510; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 515; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 520; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 525; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 530; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 550; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 555; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 560; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 565; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 575; c: TEnemyAttacker3; x: 0; y: 240),


    (f: 600; c: TEnemyBoss7; x: 0; y: 200 )
  );

// Fin niveau 7

// Niveau 8

 EnemyAdventTable8: array[0..32] of TEnemyAdvent = (


    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 160; c: TEnemyUFO2; x: 0; y: 240),
    (f: 170; c: TEnemyUFO2; x: 0; y: 240),
    (f: 180; c: TEnemyUFO2; x: 0; y: 240),
    (f: 190; c: TEnemyUFO2; x: 0; y: 240),
    (f: 200; c: TEnemyUFO2; x: 0; y: 240),

    (f: 220; c: TEnemyAttacker; x: 0; y: 100),
    (f: 230; c: TEnemyAttacker; x: 0; y: 150),
    (f: 240; c: TEnemyAttacker; x: 0; y: 200),
    (f: 250; c: TEnemyAttacker; x: 0; y: 250),
    (f: 260; c: TEnemyAttacker; x: 0; y: 300),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 100; c: TEnemyUFO2; x: 0; y: 0),
    (f: 350; c: TEnemyUFO2; x: 0; y: 120),
    (f: 350; c: TEnemyUFO2; x: 0; y: 240),
    (f: 350; c: TEnemyUFO2; x: 0; y: 360),

    (f: 450; c: TEnemyUFO; x: 0; y: 60),
    (f: 450; c: TEnemyUFO; x: 0; y: 180),
    (f: 450; c: TEnemyUFO; x: 0; y: 300),
    (f: 450; c: TEnemyUFO; x: 0; y: 420),

    (f: 550; c: TEnemyUFO2; x: 0; y: -60),
    (f: 550; c: TEnemyUFO2; x: 0; y: 60),
    (f: 550; c: TEnemyUFO2; x: 0; y: 180),
    (f: 550; c: TEnemyUFO2; x: 0; y: 300),


    (f: 615; c: TEnemyBoss8; x: 0; y: 200 )
  );

// Fin niveau 8

// Niveau 9

 EnemyAdventTable9: array[0..32] of TEnemyAdvent = (


    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 120; c: TEnemyAttacker; x: 0; y: 200),
    (f: 140; c: TEnemyAttacker; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker; x: 0; y: 200),
    (f: 155; c: TEnemyAttacker; x: 0; y: 100),

    (f: 160; c: TEnemyUFO; x: 0; y: 140),
    (f: 170; c: TEnemyUFO; x: 0; y: 340),
    (f: 180; c: TEnemyUFO; x: 0; y: 240),
    (f: 190; c: TEnemyUFO; x: 0; y: 140),
    (f: 200; c: TEnemyUFO; x: 0; y: 40),

    (f: 220; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 230; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 240; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 250; c: TEnemyAttacker3; x: 0; y: 240),
    (f: 260; c: TEnemyAttacker3; x: 0; y: 240),

    (f: 270; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 280; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 290; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 300; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 305; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 100; c: TEnemyUFO2; x: 0; y: 0),
    (f: 350; c: TEnemyUFO2; x: 0; y: 120),
    (f: 350; c: TEnemyUFO2; x: 0; y: 240),
    (f: 350; c: TEnemyUFO2; x: 0; y: 360),

    (f: 450; c: TEnemyUFO; x: 0; y: 60),
    (f: 450; c: TEnemyUFO; x: 0; y: 180),
    (f: 450; c: TEnemyUFO; x: 0; y: 300),
    (f: 450; c: TEnemyUFO; x: 0; y: 420),

    (f: 550; c: TEnemyAttacker2; x: 0; y: -60),
    (f: 550; c: TEnemyAttacker2; x: 0; y: 60),
    (f: 550; c: TEnemyAttacker2; x: 0; y: 180),
    (f: 550; c: TEnemyAttacker2; x: 0; y: 300),

    (f: 615; c: TEnemyBoss9; x: 0; y: 200 )
  );

// Fin niveau 9

// Niveau 10

 EnemyAdventTable10: array[0..53] of TEnemyAdvent = (

    (f: 100; c: TEnemyAttacker; x: 0; y: 100),
    (f: 100; c: TEnemyAttacker; x: 0; y: 200),
    (f: 100; c: TEnemyAttacker; x: 0; y: 300),
    (f: 100; c: TEnemyAttacker; x: 0; y: 200),
    (f: 100; c: TEnemyAttacker; x: 0; y: 100),

    (f: 150; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 150; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 150; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 150; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 150; c: TEnemyAttacker2; x: 0; y: 100),


    (f: 200; c: TEnemyAttacker3; x: 0; y: 100),
    (f: 200; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 200; c: TEnemyAttacker3; x: 0; y: 300),
    (f: 200; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 200; c: TEnemyAttacker3; x: 0; y: 100),

    (f: 250; c: TEnemyAttacker; x: 0; y: 100),
    (f: 250; c: TEnemyAttacker; x: 0; y: 200),
    (f: 250; c: TEnemyAttacker; x: 0; y: 300),
    (f: 250; c: TEnemyAttacker; x: 0; y: 200),
    (f: 250; c: TEnemyAttacker; x: 0; y: 100),

    (f: 275; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 275; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 275; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 275; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 275; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 310; c: TEnemyAttacker3; x: 0; y: 100),
    (f: 320; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 330; c: TEnemyAttacker3; x: 0; y: 300),
    (f: 340; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 350; c: TEnemyAttacker3; x: 0; y: 100),

    (f: 400; c: TEnemyUFO2; x: 0; y: 0),
    (f: 410; c: TEnemyUFO2; x: 0; y: 120),
    (f: 420; c: TEnemyUFO2; x: 0; y: 240),
    (f: 430; c: TEnemyUFO2; x: 0; y: 360),

    (f: 435; c: TEnemyUFO; x: 0; y: 60),
    (f: 440; c: TEnemyUFO; x: 0; y: 180),
    (f: 450; c: TEnemyUFO; x: 0; y: 300),
    (f: 460; c: TEnemyUFO; x: 0; y: 420),

    (f: 500; c: TEnemyAttacker; x: 0; y: 100),
    (f: 500; c: TEnemyAttacker; x: 0; y: 200),
    (f: 500; c: TEnemyAttacker; x: 0; y: 300),
    (f: 510; c: TEnemyAttacker; x: 0; y: 200),
    (f: 520; c: TEnemyAttacker; x: 0; y: 100),

    (f: 550; c: TEnemyAttacker2; x: 0; y: 100),
    (f: 550; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 550; c: TEnemyAttacker2; x: 0; y: 300),
    (f: 550; c: TEnemyAttacker2; x: 0; y: 200),
    (f: 550; c: TEnemyAttacker2; x: 0; y: 100),

    (f: 600; c: TEnemyAttacker3; x: 0; y: 100),
    (f: 600; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 600; c: TEnemyAttacker3; x: 0; y: 300),
    (f: 600; c: TEnemyAttacker3; x: 0; y: 200),
    (f: 600; c: TEnemyAttacker3; x: 0; y: 100),

    (f:530 ; c: TEnemyBoss10; x: 0; y: 200 )
  );

// Fin niveau 10

{  TPlayerSprite  }

constructor TPlayerSprite.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_7');
  Width := Image.Width;
  Height := Image.Height;

  X := 20;
  Y := 240-Height div 2;
  Z := 2;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

procedure TPlayerSprite.DoCollision(Sprite: TSprite; var Done: Boolean);
begin
  if Sprite is TEnemy then
  begin

    MainForm.PlaySound('snd_2', False);
    Collisioned := False;
    FCounter := 0;
    FMode := 1;
    Done := False;

    Image := MainForm.ImageList.Items.Find('img_6');
    Width := Image.Width;
    Height := Image.Height;

    AnimCount := Image.PatternCount;
    AnimLooped := False;
    AnimSpeed := 15/1000;
    AnimPos := 0;
  end;
end;

procedure TPlayerSprite.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin

    if isUp in MainForm.DXInput.States then
      Y := Y - (250/1000)*MoveCount;

    if isDown in MainForm.DXInput.States then
      Y := Y + (250/1000)*MoveCount;

    if isLeft in MainForm.DXInput.States then
      X := X - (250/1000)*MoveCount;

    if isRight in MainForm.DXInput.States then
      X := X + (250/1000)*MoveCount;

    if X<0 then X := 0;
    if X>640-Width then X := 640-Width;
    if Y<0 then Y := 0;
    if Y>480-Height then Y := 480-Height;

    if isButton1 in MainForm.DXInput.States then
    begin
      if (FTamaCount<8) and (FCounter-FOldTamaTime>=100) then
      begin
        Inc(FTamaCount);
        with TTamaSprite.Create(Engine) do
        begin
          FPlayerSprite := Self;
          X := Self.X+Self.Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
          Z := 10;
        end;

        FOldTamaTime := FCounter;
      end;
    end;

    Collision;
  end else if FMode=1 then
  begin
    if FCounter>200 then
    begin
      FCounter := 0;
      FMode := 2;
      Visible := False;
    end;
  end else if FMode=2 then
  begin
    if FCounter>1500 then
    begin
      MainForm.FNextScene := gsGameOver;

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;
{  TTamaSprite  }

constructor TTamaSprite.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_5');
  Z := 2;
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

destructor TTamaSprite.Destroy;
begin
  Dec(FPlayerSprite.FTamaCount);
  inherited Destroy;
end;

procedure TTamaSprite.DoCollision(Sprite: TSprite; var Done: Boolean);
begin
  if (Sprite is TEnemy) and (not (Sprite is TEnemyTama)) then
  begin
    TEnemy(Sprite).Hit;
    Dead;
  end;
  Done := False;
end;

procedure TTamaSprite.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);
  X := X+(800/1000)*MoveCount;

  if X>=640 then Dead;

  Collision;
end;

{  TScrollBackground  }

procedure TScrollBackground.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);
  X := X - MoveCount*(60/1000)*FSpeed;
end;

{  TBakuhatu  }

constructor TBakuhatu.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_6');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
  AnimPos := Random(AnimCount);
end;

procedure TBakuhatu.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);
end;



{  TEnemyTama  }

constructor TEnemyTama.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_14');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

procedure TEnemyTama.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);
  X := X - MoveCount*(600/1000);

  if X<-Width then Dead;
end;

{  TEnemy  }

procedure TEnemy.Hit;
begin
  Dec(FLife);
  if FLife<=0 then
  begin
    Collisioned := False;
    HitEnemy(True);
  end else
    HitEnemy(False);
end;

procedure TEnemy.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
    MainForm.PlaySound('snd_2', False);
end;

{  TEnemyUFO  }

constructor TEnemyUFO.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_2');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

procedure TEnemyUFO.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 1000);

    Image := MainForm.ImageList.Items.Find('img_6');
    Width := Image.Width;
    Height := Image.Height;

    AnimCount := Image.PatternCount;
    AnimLooped := False;
    AnimSpeed := 15/1000;
    AnimPos := 0;
  end;
end;

procedure TEnemyUFO.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    X := X - MoveCount*(300/1000);
    Y := Y + Cos256(FCounter div 15)*2;

    if X<-Width then Dead;
  end else if FMode=2 then
  begin
    X := X - MoveCount*(300/1000);
    if FCounter>200 then
      Dead;
  end;

  FCounter := FCounter + MoveCount;
end;


constructor TEnemyUFO2.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_12');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

procedure TEnemyUFO2.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 1000);

    Image := MainForm.ImageList.Items.Find('img_6');
    Width := Image.Width;
    Height := Image.Height;

    AnimCount := Image.PatternCount;
    AnimLooped := False;
    AnimSpeed := 15/1000;
    AnimPos := 0;
  end;
end;

procedure TEnemyUFO2.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    X := X - MoveCount*(300/1000);
    Y := Y + Cos256(FCounter div 15)*2;

    if X<-Width then Dead;
  end else if FMode=2 then
  begin
    X := X - MoveCount*(300/1000);
    if FCounter>200 then
      Dead;
  end;

  FCounter := FCounter + MoveCount;
end;


{  TEnemyAttacker  }

constructor TEnemyAttacker.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_3');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

procedure TEnemyAttacker.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 1000);

    Image := MainForm.ImageList.Items.Find('img_6');
    Width := Image.Width;
    Height := Image.Height;

    AnimCount := Image.PatternCount;
    AnimLooped := False;
    AnimSpeed := 15/1000;
    AnimPos := 0;
  end;
end;

procedure TEnemyAttacker.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    X := X - MoveCount*(300/1000)-FCounter div 128;

    if X<-Width then Dead;
  end else if FMode=2 then
  begin
    X := X - MoveCount*(300/1000);
    if FCounter>200 then
      Dead;
  end;

  FCounter := FCounter + MoveCount;
end;

// Nouveau Attacker
constructor TEnemyAttacker2.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_8');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

procedure TEnemyAttacker2.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 1000);

    Image := MainForm.ImageList.Items.Find('img_6');
    Width := Image.Width;
    Height := Image.Height;

    AnimCount := Image.PatternCount;
    AnimLooped := False;
    AnimSpeed := 15/1000;
    AnimPos := 0;
  end;
end;

procedure TEnemyAttacker2.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    X := X - MoveCount*(300/1000)-FCounter div 128;

    if X<-Width then Dead;
  end else if FMode=2 then
  begin
    X := X - MoveCount*(300/1000);
    if FCounter>200 then
      Dead;
  end;

  FCounter := FCounter + MoveCount;
end;
// Fin Attacker

constructor TEnemyAttacker3.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_13');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;
end;

procedure TEnemyAttacker3.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 1000);

    Image := MainForm.ImageList.Items.Find('img_6');
    Width := Image.Width;
    Height := Image.Height;

    AnimCount := Image.PatternCount;
    AnimLooped := False;
    AnimSpeed := 15/1000;
    AnimPos := 0;
  end;
end;

procedure TEnemyAttacker3.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    X := X - MoveCount*(300/1000)-FCounter div 128;

    if X<-Width then Dead;
  end else if FMode=2 then
  begin
    X := X - MoveCount*(300/1000);
    if FCounter>200 then
      Dead;
  end;

  FCounter := FCounter + MoveCount;
end;


{  TEnemyBoss  }

constructor TEnemyBoss.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_4');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 30;
end;

procedure TEnemyBoss.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain2;
      MainForm.StatusBar.SimpleText:= 'Level: 2';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;

// Boss2

{  TEnemyBoss  }

constructor TEnemyBoss2.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_9');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 40;
end;

procedure TEnemyBoss2.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss2.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain3;
       MainForm.StatusBar.SimpleText:= 'Level: 3';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss2

// Boss3

{  TEnemyBoss  }

constructor TEnemyBoss3.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_10');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 45;
end;

procedure TEnemyBoss3.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss3.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain4;
       MainForm.StatusBar.SimpleText:= 'Level: 4';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss3

// Boss3

{  TEnemyBoss  }

constructor TEnemyBoss4.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_15');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 50;
end;

procedure TEnemyBoss4.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss4.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain5;
       MainForm.StatusBar.SimpleText:= 'Level: 5';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss4

// Boss3

{  TEnemyBoss  }

constructor TEnemyBoss5.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_16');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 55;
end;

procedure TEnemyBoss5.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss5.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain6;
       MainForm.StatusBar.SimpleText:= 'Level: 6';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss5

// Boss6

{  TEnemyBoss  }

constructor TEnemyBoss6.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_9');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 55;
end;

procedure TEnemyBoss6.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss6.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain7;
       MainForm.StatusBar.SimpleText:= 'Level: 7';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss6


// Boss7

{  TEnemyBoss  }

constructor TEnemyBoss7.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_17');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 60;
end;

procedure TEnemyBoss7.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss7.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain8;
       MainForm.StatusBar.SimpleText:= 'Level: 8';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss7

// Boss8

{  TEnemyBoss  }

constructor TEnemyBoss8.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_18');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 65;
end;

procedure TEnemyBoss8.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss8.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain9;
       MainForm.StatusBar.SimpleText:= 'Level: 9';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss8

// Boss9

{  TEnemyBoss  }

constructor TEnemyBoss9.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_19');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 70;
end;

procedure TEnemyBoss9.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 100000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss9.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>450 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(30) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(500) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsMain10;
       MainForm.StatusBar.SimpleText:= 'Level: 10';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss9

// Boss10

{  TEnemyBoss  }

constructor TEnemyBoss10.Create(AParent: TSprite);
begin
  inherited Create(AParent);
  Image := MainForm.ImageList.Items.Find('img_11');
  Width := Image.Width;
  Height := Image.Height;

  AnimCount := Image.PatternCount;
  AnimLooped := True;
  AnimSpeed := 15/1000;

  Collisioned := False;

  FLife := 120;
end;

procedure TEnemyBoss10.HitEnemy(Deaded: Boolean);
begin
  if Deaded then
  begin
    MainForm.PlaySound('snd_2', False);
    FMode := 2;
    FCounter := 0;

    Inc(MainForm.FHitPoint, 200000);
  end else
  begin
    MainForm.PlaySound('snd_3', False);
    Inc(MainForm.FHitPoint, 100);
  end;
end;

procedure TEnemyBoss10.DoMove(MoveCount: Integer);
var
  i: Integer;
begin
  inherited DoMove(MoveCount);

  if FMode=0 then
  begin
    if X>350 then
      X := X - MoveCount*(300/1000)
    else
    begin
      Collisioned := True;
      FMode := 1;
      FPutTama := True;
    end;

    Y := Y + Cos256(FCounter div 15)*5;
  end else if FMode=1 then
  begin

    Y := Y + Cos256(FCounter div 15)*5;

    if FPutTama then
    begin
      if FTamaT>100 then
      begin
        with TEnemyTama.Create(Engine) do
        begin
          FPlayerSprite := Self;
          Z := 1;
          X := Self.X-Width;
          Y := Self.Y+Self.Height div 2-Height div 2;
        end;

        Inc(FTamaF);
        if FTamaF>Random(50) then
          FPutTama := False;

        FTamaT := 0;
      end;

      FTamaT := FTamaT + MoveCount;
    end else
    begin
      FTamaT := FTamaT + MoveCount;
      if FTamaT>2000+Random(600) then
      begin
        FPutTama := True;
        FTamaF := 0;
        FTamaT := 0;
      end;
    end;
  end else if FMode=2 then
  begin
    for i:=0 to 20 do
    begin
      with TBakuhatu.Create(Engine) do
      begin
        Z := 10;
        X := Self.X+Random(Self.Width)-16;
        Y := Self.Y+Random(Self.Height)-16;
       end;

    Inc(MainForm.FTokuten, 1000);
   end;

   FMode := 3;
  end else if FMode=3 then
  begin
    if FCounter>3000 then
    begin
      MainForm.FNextScene := gsEndGame;
       MainForm.StatusBar.SimpleText:= 'Congratulations! You are the best!';

      MainForm.PlaySound('snd_1', False);
      MainForm.PalleteAnim(RGBQuad(0, 0, 0), 300);
      Sleep(200);
    end;
  end;

  FCounter := FCounter + MoveCount;
end;


// Fin Boss10

procedure TMainForm.FormCreate(Sender: TObject);
begin

  Music.FileName:= FileSource.FileName;
  Music.Open;
  Music.Play;

  ImageList.Items.MakeColorTable;

  DXDraw.ColorTable := ImageList.Items.ColorTable;
  DXDraw.DefColorTable := ImageList.Items.ColorTable;
  DXDraw.UpdatePalette;

  OptionFullScreen.Checked := True;
  OptionFullScreenClick(OptionFullScreen);

  OptionSound.Checked := False;
  OptionSoundClick(OptionSound);

//  Music.FileName:= FileSource1.FileName;
{  Music.Open;
  Music.Enabled:= true;
  Music.Play;}


  GameStartClick(GameStart);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DXTimer.Enabled := False;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if (ssAlt in Shift) and (Key=VK_RETURN) then
  begin
    OptionFullScreenClick(OptionFullScreen)
  end;
  if (ssShift in Shift) and (Key= VK_Insert) then
   begin
    if MainForm.FScene= gsMain then MainForm.FNextScene:= gsMain2
    else if MainForm.FScene= gsMain2 then MainForm.FNextScene:= gsMain3
    else if MainForm.FScene= gsMain3 then MainForm.FNextScene:= gsMain4
    else if MainForm.FScene= gsMain4 then MainForm.FNextScene:= gsMain5
    else if MainForm.FScene= gsMain5 then MainForm.FNextScene:= gsMain6
    else if MainForm.FScene= gsMain6 then MainForm.FNextScene:= gsMain7
    else if MainForm.FScene= gsMain7 then MainForm.FNextScene:= gsMain8
    else if MainForm.FScene= gsMain8 then MainForm.FNextScene:= gsMain9
    else if MainForm.FScene= gsMain9 then MainForm.FNextScene:= gsMain10
    else if MainForm.FScene= gsMain10 then MainForm.FNextScene:= gsEndGame;
   end;
end;

procedure TMainForm.GameStartClick(Sender: TObject);
begin

  FHitPoint := 0;

  StartScene(gsTitle);
end;

procedure TMainForm.GamePauseClick(Sender: TObject);
begin

  GamePause.Checked := not GamePause.Checked;
  DXTimer.Enabled := not GamePause.Checked;
end;

procedure TMainForm.GameExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.OptionFullScreenClick(Sender: TObject);
begin
  OptionFullScreen.Checked := not OptionFullScreen.Checked;

  if OptionFullScreen.Checked then
  begin
    DXDraw.Finalize;

    if not (doFullScreen in DXDraw.Options) then
      StoreWindow;

    DXDraw.Options := DXDraw.Options + [doFullScreen];
    DXDraw.Display.Width := 640;
    DXDraw.Display.Height := 480;
    DXDraw.Display.BitCount := 8;
    DXDraw.Initialize;
  end else
  begin
    DXDraw.Finalize;

    if doFullScreen in DXDraw.Options then
      RestoreWindow;

    DXDraw.Options := DXDraw.Options - [doFullScreen];
    DXDraw.Display.Width := 640;
    DXDraw.Display.Height := 480;
    DXDraw.Display.BitCount := 8;
    DXDraw.Initialize;
  end;
end;

procedure TMainForm.OptionSoundClick(Sender: TObject);
begin
  OptionSound.Checked := not OptionSound.Checked;

  if OptionSound.Checked then
  begin
    if not DXSound.Initialized then
    begin
      try
        DXSound.Initialize;
      except
        OptionSound.Checked := False;
      end;
    end;
  end else
    DXSound.Finalize;
end;

procedure TMainForm.OptionShowFPSClick(Sender: TObject);
begin
//  OptionShowFPS.Checked := not OptionShowFPS.Checked;
end;

procedure TMainForm.DXDrawInitializing(Sender: TObject);
begin
  if doFullScreen in DXDraw.Options then
  begin
    BorderStyle := bsNone;
    DXDraw.Cursor := crNone;
  end else
  begin
    BorderStyle := bsSingle;
    DXDraw.Cursor := crDefault;
  end;
end;

procedure TMainForm.DXDrawInitialize(Sender: TObject);
begin
  DXTimer.Enabled := True;
end;

procedure TMainForm.DXDrawFinalize(Sender: TObject);
begin
  DXTimer.Enabled := False;
end;

procedure TMainForm.DXTimerActivate(Sender: TObject);
begin
  Caption := Application.Title;
end;

procedure TMainForm.DXTimerDeactivate(Sender: TObject);
begin
  Caption := Application.Title + ' [Pause]';
end;

procedure TMainForm.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
  if not DXDraw.CanDraw then exit;

  DXInput.Update;

  case FScene of
    gsTitle   : SceneTitle;
    gsMain    : SceneMain;
    gsGameOver: SceneGameOver;
    gsMain2   : SceneMain2;
    gsMain3   : SceneMain3;
    gsMain4   : SceneMain4;
    gsMain5   : SceneMain5;
    gsMain6   : SceneMain6;
    gsMain7   : SceneMain7;
    gsMain8   : SceneMain8;
    gsMain9   : SceneMain9;
    gsMain10  : SceneMain10;
    gsEndGame : SceneEndGame;
  end;

  if FNextScene<>gsNone then
  begin
    StartScene(FNextScene);
    FNextScene := gsNone;
  end;

{  if OptionShowFPS.Checked then
  begin
    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clWhite;
      Font.Size := 12;
      Textout(0, 0, 'FPS: '+inttostr(DXTimer.FrameRate));
      Release;
    end;
  end;  }

  DXDraw.Flip;
end;

procedure TMainForm.BlinkStart;
begin
  FBlink := 0;
  FBlinkTime := GetTickCount;
end;

procedure TMainForm.BlinkUpdate;
begin
  if GetTickCount<>FBlinkTime then
  begin
    FBlink := FBlink + (GetTickCount-FBlinkTime);
    FBlinkTime := GetTickCount;
  end;
end;

procedure TMainForm.PlaySound(const Name: string; Wait: Boolean);
begin
  if OptionSound.Checked then
  begin
    DXWaveList.Items.Find(Name).Play(Wait);
  end;
end;

procedure TMainForm.PalleteAnim(Col: TRGBQuad; Time: Integer);

  function ComposeColor(Dest, Src: TRGBQuad; Percent: Integer): TRGBQuad;
  begin
    with Result do
    begin
      rgbRed := Src.rgbRed+((Dest.rgbRed-Src.rgbRed)*Percent div 256);
      rgbGreen := Src.rgbGreen+((Dest.rgbGreen-Src.rgbGreen)*Percent div 256);
      rgbBlue := Src.rgbBlue+((Dest.rgbBlue-Src.rgbBlue)*Percent div 256);
      rgbReserved := 0;
    end;
  end;

var
  i, t, t2: Integer;
  ChangePalette: Boolean;
  c: Integer;
begin
  if DXDraw.Initialized then
  begin
    c := DXDraw.Surface.ColorMatch(RGB(Col.rgbRed, Col.rgbGreen, Col.rgbBlue));

    ChangePalette := False;
    if DXDraw.CanPaletteAnimation then
    begin
      t := GetTickCount;
      while Abs(GetTickCount-t)<Time do
      begin
        t2 := Trunc(Abs(GetTickCount-t)/Time*255);

        for i:=0 to 255 do
          DXDraw.ColorTable[i] := ComposeColor(Col, DXDraw.DefColorTable[i], t2);

        DXDraw.UpdatePalette;
        ChangePalette := True;
      end;
    end else
      Sleep(Time);

    DXDraw.Surface.Fill(c);
    DXDraw.Flip;
    DXDraw.Surface.Fill(c);
    DXDraw.Flip;
    DXDraw.Surface.Fill(c);
    DXDraw.Flip;
    DXDraw.Surface.Fill(c);
    DXDraw.Flip;

    if ChangePalette then
    begin
      DXDraw.ColorTable := DXDraw.DefColorTable;
      DXDraw.UpdatePalette;
    end;

    DXDraw.Surface.Fill(c);
    DXDraw.Flip;
  end;
end;

procedure TMainForm.StartScene(Scene: TGameScene);
begin
  EndScene;

  DXInput.States := [];

  FScene := Scene;

  BlinkStart;

  case FScene of
    gsTitle   : StartSceneTitle;
    gsMain    : StartSceneMain;
    gsGameOver: StartSceneGameOver;
    gsMain2   : StartSceneMain2;
    gsMain3   : StartSceneMain3;
    gsMain4   : StartSceneMain4;
    gsMain5   : StartSceneMain5;
    gsMain6   : StartSceneMain6;
    gsMain7   : StartSceneMain7;
    gsMain8   : StartSceneMain8;
    gsMain9   : StartSceneMain9;
    gsMain10  : StartSceneMain10;
//    gsEndGame : StartEndGame;
  end;
end;

procedure TMainForm.StartSceneTitle;
begin

end;

procedure TMainForm.StartSceneMain;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Niveau 2
procedure TMainForm.StartSceneMain2;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 2

// Niveau 3
procedure TMainForm.StartSceneMain3;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 3

// Niveau 4
procedure TMainForm.StartSceneMain4;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 4

// Niveau 5
procedure TMainForm.StartSceneMain5;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 5

// Niveau 6
procedure TMainForm.StartSceneMain6;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 6

// Niveau 7
procedure TMainForm.StartSceneMain7;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 7

// Niveau 8
procedure TMainForm.StartSceneMain8;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 8

// Niveau 9
procedure TMainForm.StartSceneMain9;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 9

// Niveau 10
procedure TMainForm.StartSceneMain10;
var
  i, j: Integer;
begin

  FEnemyAdventPos := 0;
  FFrame := 0;
  FTokuten := 0;


  TPlayerSprite.Create(SpriteEngine.Engine);

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 10;
    Z := -13;
    FSpeed := 0.5;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 8);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 30;
    Z := -12;
    FSpeed := 1;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 4);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;

  with TScrollBackground.Create(SpriteEngine.Engine) do
  begin
    SetMapSize(200, 10);
    Image := ImageList.Items.Find('img_1');
    Y := 40;
    Z := -11;
    FSpeed := 2;
    Tile := True;

    for i:=0 to MapHeight-1 do
      for j:=0 to MapWidth-1 do
      begin
        Chips[j, i] := Image.PatternCount-Random(Image.PatternCount div 2);
        if Random(100)<95 then Chips[j, i] := -1;
      end;
  end;
end;

// Fin niveau 10


procedure TMainForm.StartSceneGameOver;
begin

end;

{procedure TMainForm.StartSceneEndGame;
begin

end;}

procedure TMainForm.EndScene;
begin
  case FScene of
    gsTitle   : EndSceneTitle;
    gsMain    : EndSceneMain;
    gsGameOver: EndSceneGameOver;
    gsMain2   : EndSceneMain2;
    gsMain3   : EndSceneMain3;
    gsMain4   : EndSceneMain4;
    gsMain5   : EndSceneMain5;
    gsMain6   : EndSceneMain6;
    gsMain7   : EndSceneMain7;
    gsMain8   : EndSceneMain8;
    gsMain9   : EndSceneMain9;
    gsMain10  : EndSceneMain10;
//    gsEndGame : EndSceneEndGame;
  end;
end;

procedure TMainForm.EndSceneTitle;
begin

end;

procedure TMainForm.EndSceneMain;
begin

  SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain2;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain3;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain4;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain5;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain6;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain7;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain8;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain9;
begin
     SpriteEngine.Engine.Clear;
end;

procedure TMainForm.EndSceneMain10;
begin
     SpriteEngine.Engine.Clear;
end;


procedure TMainForm.EndSceneGameOver;
begin

end;

procedure TMainForm.SceneTitle;

begin

  DXDraw.Surface.Fill(0);
  with DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clBlue;
    StatusBar.SimpleText:= 'Level: 1';
    Font.Size := 40;
    Font.Style:= Font.Style + [FsBold];
    Textout(175, 100, 'LaserWar');

    if (FBlink div 300) mod 2=0 then
    begin
      Font.Color := clWhite;
      Font.Size := 30;
      Font.Style:= Font.Style - [FsBold];
      Textout(80, 300, 'Press SpaceBar or Button 1');
    end;



    BlinkUpdate;

    Release;
  end;

  if isButton1 in DXInput.States then
  begin
    PlaySound('snd_1', False);
    PalleteAnim(RGBQuad(0, 0, 0), 300);
    Sleep(200);

    StartScene(gsMain);
  end;
end;

procedure TMainForm.SceneMain;
var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable)) and
    (EnemyAdventTable[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;

// Niveau 2
procedure TMainForm.SceneMain2;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable2)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable2)) and
    (EnemyAdventTable2[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable2[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 2

// Niveau 3
procedure TMainForm.SceneMain3;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable3)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable3)) and
    (EnemyAdventTable3[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable3[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 3

// Niveau 4
procedure TMainForm.SceneMain4;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable4)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable4)) and
    (EnemyAdventTable4[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable4[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 4

// Niveau 5
procedure TMainForm.SceneMain5;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable5)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable5)) and
    (EnemyAdventTable5[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable5[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 5

// Niveau 6
procedure TMainForm.SceneMain6;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable6)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable6)) and
    (EnemyAdventTable6[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable6[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 6

// Niveau 7
procedure TMainForm.SceneMain7;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable7)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable7)) and
    (EnemyAdventTable7[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable7[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 7

// Niveau 8
procedure TMainForm.SceneMain8;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable8)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable8)) and
    (EnemyAdventTable8[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable8[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 8

// Niveau 9
procedure TMainForm.SceneMain9;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable9)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable9)) and
    (EnemyAdventTable9[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable9[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 9

// Niveau 10
procedure TMainForm.SceneMain10;

var
  Enemy: TSprite;
begin

  SpriteEngine.Move(1000 div 60);
  SpriteEngine.Dead;

  while (Low(EnemyAdventTable10)<=FEnemyAdventPos) and (FEnemyAdventPos<=High(EnemyAdventTable10)) and
    (EnemyAdventTable10[FEnemyAdventPos].f<=FFrame) do
  begin
    with EnemyAdventTable10[FEnemyAdventPos] do
    begin
      Enemy := c.Create(SpriteEngine.Engine);
      Enemy.x := 640+x;
      Enemy.y := y;
    end;

    Inc(FEnemyAdventPos);
  end;

  DXDraw.Surface.Fill(0);
  if FNextScene=gsNone then
  begin
    SpriteEngine.Draw;

    with DXDraw.Surface.Canvas do
    begin
      Brush.Style := bsClear;
      Font.Color := clBlue;
      Font.Size := 20;
      Textout(10, 10, IntToStr(FHitPoint));
      Release;
    end;
  end;

  Inc(FFrame);
end;
// Fin niveau 10

procedure TMainForm.SceneGameOver;
begin
  DXDraw.Surface.Fill(0);
  with DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clRed;
    Font.Size := 40;
    Textout(180, 100, 'Game Over');
    StatusBar.SimpleText:= 'GameOver!';


    if (FBlink div 300) mod 2=0 then
    begin
      Font.Color := clWhite;
      Font.Size := 30;
      Textout(90, 300, 'Press SpaceBar or Button 1');
    end;

    BlinkUpdate;

    Release;
  end;

  if isButton1 in DXInput.States then
  begin
    PlaySound('snd_1', False);
    PalleteAnim(RGBQuad(0, 0, 0), 300);
    Sleep(200);

    ScoreBox.Score:= FHitPoint;
    ScoreBox.Execute;
    FHitPoint:=0;

    StartScene(gsTitle);
  end;
end;


procedure TMainForm.SceneEndGame;
begin
  DXDraw.Surface.Fill(0);
  with DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clGreen;
    Font.Size := 40;
    Textout(100, 100, 'Thanks for playing!');
    Font.Color := clBlue;
    Font.Size:= 20;
    Font.Style:= Font.Style + [FsUnderline];
    TextOut(240, 180, 'Credits:');
    Font.Style:= Font.Style - [FsUnderline];
    TextOut(100, 215, 'Programming: Colin LAPLACE');
    TextOut(100, 245, 'Graphics:    SpriteLib');
    if (FBlink div 300) mod 2=0 then
    begin
      Font.Color := clWhite;
      Font.Size := 30;
      Textout(90, 350, 'Press SpaceBar or Button 1');
    end;

    BlinkUpdate;

    Release;
  end;

  if isButton1 in DXInput.States then
  begin
    PlaySound('snd_1', False);
    PalleteAnim(RGBQuad(0, 0, 0), 300);
    Sleep(200);

    StartScene(gsTitle);
  end;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
GamePauseClick(Sender);
with AboutBox do
 begin
  ShowModal;
  if ModalResult= MrOK then
  Close;
 end;
GamePauseClick(Sender);
end;

procedure TMainForm.HighScores1Click(Sender: TObject);
begin
GamePauseClick(Sender);
ScoreBox.Show;
GamePauseClick(Sender);
end;

procedure TMainForm.MusicNotify(Sender: TObject);
begin
Music.Rewind;
Music.Play;
end;

end.

